(** DkSDK Metatype offshoring implementation.

{1 Credits}

This code is based heavily on Oleg Kiselyov's work and public domain code.

{v
Oleg Kiselyov,
Generating C: Heterogeneous metaprogramming system description,
Science of Computer Programming,
Volume 231,
2024,
103015,
ISSN 0167-6423,
https://doi.org/10.1016/j.scico.2023.103015.
(https://www.sciencedirect.com/science/article/pii/S0167642323000977)
Abstract: Heterogeneous metaprogramming systems use a higher-level host language to generate code in a lower-level object language. Their appeal is taking advantage of the module system, higher-order functions, data types, type system and verification tools of the host language to quicker produce high-performant lower-level code with some correctness guarantees. We present two heterogeneous metaprogramming systems whose host language is OCaml and object language is C. The first relies on offshoring: treating a subset of (MetaOCaml-generated) OCaml as a different notation for (a subset of) C. The second embeds C in OCaml in tagless-final style. The systems have been used in several projects, including the generation of C supersets OpenCL and OpenMP. Generating C with some correctness guarantees is far less trivial than it may appear, with pitfalls abound: e.g., local variables may only be introduced in statement context; mutable variables are not first-class. Maintenance has challenges of its own, e.g., extensibility. On many examples, we expound the pitfalls we have come across in our experience, and describe the design and implementation to address them.
Keywords: Heterogeneous metaprogramming; Code generation; Tagless-final
v}

{1 Caution}

There is a big caution implied within Oleg's ["offshoring.ml"] file ...

We take advantage of the fact that the our OCaml source is presumed
to have been generated by MetaOCaml: All identifiers
have unique names and all types are fully qualified.

Said another way, since we do not (yet) use BER MetaOCaml and instead
rely on PPX infrastructure, we cannot guarantee unique names and
fully qualified types. It is quite possible that user-specified
{b expressions may fail to compile!}.

*)

module Offshoring = Offshoring
module OffshoringIR = OffshoringIR
module OffshoringIR_pp = OffshoringIR_pp

(** [Xmas2023] is the quick, ready-to use sample for
    {:https://gitlab.com/diskuv/samples/merrychristmas2023}.
    
    See that README for how to use it. *)
module Xmas2023 : sig
  (** Converter module that can be found in
      {:https://okmij.org/ftp/meta-programming/tutorial/offshore_simple.ml}.  *)
  module SumArConv : sig
    type pathname = string

    val type_conv : pathname -> OffshoringIR.typ list -> OffshoringIR.typ
    val id_conv : pathname -> string -> string
  end

  val better_backtraces_worse_diagnostics : bool ref
  (** Sadly this magic flag needs to exist to tradeoff between a good backtrace
      on errors, or a good error message on errors.
      Defaults to [true]. *)

  val compile_to_ir :
    (module Offshoring.converters) ->
    Lexing.position * Parsetree.expression * Lexing.position ->
    OffshoringIR.proc_t
  (** [compile_to_ir] compiles an expression to an intermediate language.
      The intermediate language can be translated to other languages.

      Today (Christmas 2023) this project only has C. *)

  val print_c :
    string ->
    (module Offshoring.converters) ->
    Lexing.position * Parsetree.expression * Lexing.position ->
    unit
  (** [print_c] compiles an expression directly to C. *)
end

(**/**)

module ForTesting : sig
  module Codelib = Codelib
end
